local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTracker", true);

function NeedjaTracker:ShowRollStatistics(channel)
    local db = self.db.char;
    if # db.RollStatistics == 0 then
        PrintToChat(L.msg_stat_head_empty, channel);
        return;
    end
    PrintToChat(L.msg_stat_head, channel);
    table.sort(db.RollStatistics, function(a, b) return (a.need or 0) > (b.need or 0) end);
    local top = db.RollStatistics[1].need or 0;
    table.sort(db.RollStatistics, function(a, b) return (a.win or 0) > (b.win or 0) end);
    local n, data;
    for n, data in pairs(db.RollStatistics) do
        if top > 0 and (data.need or 0) == top then
            PrintToChat((L.msg_stat_top):format(n, data.player,
                (data.win or 0), (data.need or 0), (data.greed or 0),
                (data.disenchant or 0), (data.pass or 0)),
                channel);
        elseif (data.need or 0) > 0 then
            PrintToChat((L.msg_stat_needja):format(n, data.player,
                (data.win or 0), (data.need or 0), (data.greed or 0),
                (data.disenchant or 0), (data.pass or 0)),
                channel);
        else
            PrintToChat((L.msg_stat_line):format(n, data.player,
                (data.win or 0), (data.need or 0), (data.greed or 0),
                (data.disenchant or 0), (data.pass or 0)),
                channel);
        end
    end
end

function NeedjaTracker:ShowRollHistory(channel)
    local db = self.db.char;
    if # db.RollHistory == 0 then
        PrintToChat(L.msg_hist_head_empty, channel);
        return;
    end
    PrintToChat(L.msg_hist_head, channel);
    local n, data;
    for n, data in pairs(db.RollHistory) do
        if data.choice == "pass" then
            PrintToChat((L.msg_hist_pass):format(n, data.item), channel);
        elseif data.choice == "need" then
            PrintToChat((L.msg_hist_need):format(n, data.item, data.player,
                L["roll_" .. (data.choice or "unknown")], (data.roll or "?")),
                channel);
        else
            PrintToChat((L.msg_hist_win):format(n, data.item, data.player,
                L["roll_" .. (data.choice or "unknown")], (data.roll or "?")),
                channel);
        end
    end
end
